/*  
  LoginDlg.java

  11.03.2001: tk, sourcecode released under the GPL.

  Copyright (c)2001 by SoPra2001 Gruppe 14, University of Dortmund
  mail for contact: thomas.kindler@gmx.de

  This program is free software; you can redistribute it and/or modify it 
  under the terms of the GNU General Public License as published by the 
  Free Software Foundation; either version 2 of the License, or (at your 
  option) any later version. Please read the included "copying.txt" file,
  or the full License at http://www.gnu.org/copyleft for more details.
*/

package gui;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import logic.*;

public class LoginDlg extends JDialog {
  JPanel panel1 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JButton jButton_Abbrechen = new JButton();
  JButton jButton_OK = new JButton();
  FlowLayout flowLayout1 = new FlowLayout();
  JPanel jPanel2 = new JPanel();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JTextField jTextField_Username = new JTextField();
  JPasswordField jPasswordField_Passwort = new JPasswordField();
  JLabel jLabel3 = new JLabel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JLabel jLabel4 = new JLabel();

  private boolean userClickedOK = false;
  private Nutzerverwaltung nutzerverwaltung;
  private Projekt projekt;


  public LoginDlg(JComponent parent, Nutzerverwaltung nutzerverwaltung, Projekt projekt) {
    super((Frame)parent.getTopLevelAncestor(), "Login", true);
    this.nutzerverwaltung = nutzerverwaltung;
    this.projekt = projekt;
    jbInit();
    pack();
    setLocationRelativeTo(parent);
    getRootPane().setDefaultButton(jButton_OK);
  }


  public boolean userClickedOK() {
    return userClickedOK;
  }

  void jbInit()  {
    panel1.setLayout(borderLayout1);
    jButton_Abbrechen.setText("Abbrechen");
    jButton_Abbrechen.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButton_Abbrechen_actionPerformed(e);
      }
    });
    jButton_OK.setText("OK");
    jButton_OK.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButton_OK_actionPerformed(e);
      }
    });
    jPanel1.setLayout(flowLayout1);
    flowLayout1.setAlignment(FlowLayout.RIGHT);
    jPanel2.setLayout(gridBagLayout1);
    jLabel1.setText("Bitte geben sie ihre Zugangsdaten ein!");
    jLabel2.setDisplayedMnemonic('P');
    jLabel2.setLabelFor(jPasswordField_Passwort);
    jLabel2.setText("Passwort");
    jTextField_Username.setColumns(16);
    jPasswordField_Passwort.setColumns(16);
    jPasswordField_Passwort.setCaretPosition(0);
    jPasswordField_Passwort.setFont(new java.awt.Font("Dialog", 0, 12));
    jLabel3.setFont(new java.awt.Font("SansSerif", 1, 24));
    jLabel3.setForeground(Color.darkGray);
    jLabel3.setText("Login");
    jLabel4.setDisplayedMnemonic('U');
    jLabel4.setLabelFor(jTextField_Username);
    jLabel4.setText("Username");
    this.setResizable(false);
    this.setModal(true);
    getContentPane().add(panel1);
    panel1.add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(jButton_OK, null);
    jPanel1.add(jButton_Abbrechen, null);
    panel1.add(jPanel2, BorderLayout.CENTER);
    jPanel2.add(jPasswordField_Passwort, new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 0, 24, 32), 0, 0));
    jPanel2.add(jLabel2, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(2, 24, 24, 8), 0, 0));
    jPanel2.add(jTextField_Username, new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 0, 8, 8), 0, 0));
    jPanel2.add(jLabel1, new GridBagConstraints(0, 1, 2, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(2, 24, 8, 8), 0, 0));
    jPanel2.add(jLabel3, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 8, 16, 8), 0, 0));
    jPanel2.add(jLabel4, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(2, 24, 8, 8), 0, 0));
  }

  void jButton_OK_actionPerformed(ActionEvent e)
  {
    String name = jTextField_Username.getText();
    String passwort = new String(jPasswordField_Passwort.getPassword());

    Nutzer nutzer = nutzerverwaltung.getNutzer(name);
    if (nutzer != null)
      if (passwort.equals(nutzer.getPasswort())) {
        projekt.setCurrentNutzer(nutzer);
        userClickedOK = true;
        dispose();
        return;
      }

    JOptionPane.showMessageDialog( this,
      "Ihre Zugangsdaten sind ungueltig\n"+
      "Achten sie auf Gross/Kleinschreibung!",
      "Login fehlgeschlagen", JOptionPane.ERROR_MESSAGE
    );
  }

  void jButton_Abbrechen_actionPerformed(ActionEvent e) {
    dispose();
  }

}
