/*  
  Projekt.java

  11.03.2001: tk, sourcecode released under the GPL.

  Copyright (c)2001 by SoPra2001 Gruppe 14, University of Dortmund
  mail for contact: thomas.kindler@gmx.de

  This program is free software; you can redistribute it and/or modify it 
  under the terms of the GNU General Public License as published by the 
  Free Software Foundation; either version 2 of the License, or (at your 
  option) any later version. Please read the included "copying.txt" file,
  or the full License at http://www.gnu.org/copyleft for more details.
*/


package logic;
import java.io.*;
import java.util.zip.*;

public class Projekt implements Serializable {
  private  Planung           planung;
  private  Nutzerverwaltung  nutzerverwaltung;
  private  Nutzer            currentNutzer;
  private  String  dateiname;

  public Projekt() {
    neuesProjekt();
  }

  /**
   *  Initialisiert das Projekt auf Standardeinstellungen
   *  (nur ein Defaultnutzer, keine Termine, etc..
   */
  public void neuesProjekt()
  {
    nutzerverwaltung = new Nutzerverwaltung();
    planung          = new Planung(this);
    dateiname        = null;

    Nutzer  admin = new Nutzer(nutzerverwaltung);
    try {
      admin.setLoginName( "Projektleiter" );
      admin.setVorname( "Projektleiter" );
      admin.setName( "" );
      admin.setKommentar( "Denken sie daran, ihre Zugangsdaten und ihr Passwort zu ndern!" );
      admin.setAdmin( true );
      nutzerverwaltung.addNutzer( admin );
    } catch (Exception e) {}
    setCurrentNutzer( admin);
  }

  /**
   * Speichert das Projekt
   *
   */
  public void speichern(String dateiname) throws Exception
  {
    FileOutputStream   fos = new FileOutputStream(dateiname);
    GZIPOutputStream   zos = new GZIPOutputStream(fos);
    ObjectOutputStream oos = new ObjectOutputStream(zos);

    oos.writeObject(nutzerverwaltung);
    oos.writeObject(planung);
    oos.flush();
    oos.close();

    this.dateiname = dateiname;
    System.out.println("Speichern erfolgreich unter " + dateiname);
  }

  /**
   * Laedt das Projekt
   */
  public void laden(String dateiname) throws Exception
  {
    FileInputStream   fis = new FileInputStream(dateiname);
    GZIPInputStream   zis = new GZIPInputStream(fis);
    ObjectInputStream ois = new ObjectInputStream(zis);

    nutzerverwaltung = (Nutzerverwaltung)ois.readObject();
    planung          = (Planung)ois.readObject();
    ois.close();

    this.dateiname = dateiname;

    System.out.println("Laden erfolgreich aus " + dateiname);
  }

  /**
   * Gibt den Dateinamen zurck, unter dem das Projekt gespeichert wird.
   * @return Dateiname
   */
  public String getDateiname() {
    return dateiname;
  }

  public void setDateiname(String filename) {
    dateiname = filename;
  }

  /**
   * Gibt eine Referenz auf die Benutzerliste zurck.
   */
  public Nutzerverwaltung getNutzerverwaltung() {
    return nutzerverwaltung;
  }


  /**
   * Gibt den momentan eingeloggten Benutzer zurck.
   * @return eingeloggter Benutzer
   */
  public Nutzer getCurrentNutzer() {
    return currentNutzer;
  }

  /**
   * ndert den aktuellen Benutzer.
   * @param currentNutzer neuer Benutzer
   */
   public void setCurrentNutzer(Nutzer currentNutzer) {
     this.currentNutzer = currentNutzer;
   }

  /**
   * Gibt die Planung des Projektes zurck.
   * @return Planung des Projektes
   */
  public Planung getPlanung() {
    return planung;
  }

}
