/*  
  Stundenplan.java

  11.03.2001: tk, sourcecode released under the GPL.

  Copyright (c)2001 by SoPra2001 Gruppe 14, University of Dortmund
  mail for contact: thomas.kindler@gmx.de

  This program is free software; you can redistribute it and/or modify it 
  under the terms of the GNU General Public License as published by the 
  Free Software Foundation; either version 2 of the License, or (at your 
  option) any later version. Please read the included "copying.txt" file,
  or the full License at http://www.gnu.org/copyleft for more details.
*/


package logic;

import java.util.*;
import java.io.Serializable;

public class Stundenplan implements Serializable {

    private Hashtable terminListe = new Hashtable();

    public Enumeration getTerminListe() {
      return terminListe.keys();
    }

    public Termin getTermin(Datum datum) {
      return (Termin)terminListe.get(datum);
    }

    /**
     *  Fuegt einen Termin unter dem angegeben Datum ein.
     *  sollte an dieser Stelle schon ein Termin existieren,
     * wird dieser Ueberschrieben.
     */
    public void addTermin(Datum datum, Termin termin)  {
      terminListe.put(datum, termin);
    }

    public void removeTermin(Termin termin) {
      Enumeration enum=terminListe.keys();
      while (enum.hasMoreElements()) {
        Datum datum = (Datum)enum.nextElement();
        if (termin == terminListe.get(datum)) {
          terminListe.remove(datum);
        }
      }
    }

    public void removeTermin(Datum datum) {
      terminListe.remove(datum);
    }

}
